RoomEscapeCatalog/Controllers/AdminController.cs
using RoomEscapeCatalog.Models;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace RoomEscapeCatalog.Controllers
{
    //[RoutePrefix("admin")]
    [Route("admin/{action=Index}/{id?}")]
    public class AdminController : Controller
    {
        private IRepository<Room> rooms;

        public AdminController(IRepository<Room> rooms)
        {
            this.rooms = rooms;
        }

        // GET: Admin
        public ActionResult Index()
        {
            return View(rooms.GetAll());
        }


        // CREATE
        [Route("rooms/add")]
        [HttpGet]
        public ActionResult AddRoom()
        {
            return View(new RoomViewModel());
        }

        [Route("rooms/add")]
        [HttpPost]
        public ActionResult AddRoom(RoomViewModel roomVm)
        {
            ProcessSubmittedRoomVm(roomVm);
            rooms.Add(roomVm.Room);
            return RedirectToAction(nameof(Index));
        }

        // EDIT
        [Route("rooms/edit/{id:int}")]
        [HttpGet]
        public ActionResult EditRoom(int id)
        {
            var roomToEdit = rooms.GetAll().FirstOrDefault(room => room.Id == id);

            if (roomToEdit == null)
                return HttpNotFound($"A room with ID {id} couldn't be found");

            var roomVm = new RoomViewModel(roomToEdit);
            return View(roomVm);
        }

        [Route("rooms/edit/{id:int}")]
        [HttpPost]
        public ActionResult EditRoom(RoomViewModel roomVm)
        {
            ProcessSubmittedRoomVm(roomVm);
            rooms.Update(roomVm.Room);
            return RedirectToAction(nameof(Index));
        }

        // DELETE
        [Route("rooms/delete/{id:int}")]
        [HttpGet]
        public ActionResult DeleteRoom(int id)
        {
            rooms.Delete(id);
            return RedirectToAction(nameof(Index));
        }


        #region Private methods
        private void ProcessSubmittedRoomVm(RoomViewModel roomVm)
        {
            if (roomVm.LogoImageData != null)
            {
                var relPath = SavePostedFile(roomVm.LogoImageData);
                if (roomVm.Room.Logo == null)
                    roomVm.Room.Logo = new ImageData();
                roomVm.Room.Logo.Filename = roomVm.LogoImageData.FileName;
                roomVm.Room.Logo.Path = relPath;
                roomVm.Room.Logo.LogoOwnerRoomId = roomVm.Room.Id;
            }

            if (roomVm.GalleryImageData?.Count > 0)
            {
                foreach (var file in roomVm.GalleryImageData)
                {
                    if (file == null)
                        continue;

                    var imageData = new ImageData();
                    var relPath = SavePostedFile(file);
                    imageData.Filename = file.FileName;
                    imageData.Path = relPath;
                    imageData.GalleryOwnerRoomId = roomVm.Room.Id;
                    roomVm.Room.Gallery.Add(imageData);
                }
            }
        }

        private string SavePostedFile(HttpPostedFileBase uploadedFile)
        {
            var filename = uploadedFile.FileName;
            var relativePath = Path.Combine("Files", filename);
            var absolutePath = Server.MapPath($"~/{relativePath}");
            uploadedFile.SaveAs(absolutePath);

            return relativePath;
        }
        #endregion
    }
}

RoomEscapeCatalog/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - My ASP.NET Application</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")

    @RenderSection("styles", required: false)
</head>
<body>
    <nav class="navbar navbar-expand-md navbar-dark bg-dark">
        @Html.ActionLink("Room Escape Series", "Index", "Home", new { area = "" }, new { @class = "navbar-brand" })
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarItems" aria-controls="navbarItems" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarItems">
            <ul class="navbar-nav">
                <li class="nav-item">
                    @Html.ActionLink("Home", "Index", "Home", new { area = "" }, new { @class = "nav-link" })
                </li>
                <li class="nav-item">
                    @Html.ActionLink("Admin panel", "Index", "Admin", new { area = "" }, new { @class = "nav-link" })
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#">About</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#">Contact</a>
                </li>
            </ul>
        </div>
    </nav>

    <div class="container-lg body-content">
        @RenderBody()
    </div>

    <footer class="bg-dark">
        <p>&copy; @DateTime.Now.Year - Room Escape Series</p>
    </footer>

    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/jqueryui")
    @Scripts.Render("~/bundles/bootstrap")
    @RenderSection("scripts", required: false)
</body>
</html>